module Fold where

import Prelude hiding (Bool, True, False, Maybe, Just, Nothing)

-- A strange datatype

data IL = Cons Int IL | Err String | Mt

foldIL :: (Int-> beta-> beta)-> (String-> beta)-> beta-> IL-> beta
foldIL f e a (Cons i il) = f i (foldIL f e a il)
foldIL f e a (Err str)   = e str
foldIL f e a Mt          = a


-- Booleans:

data Bool = False | True

foldBool :: beta-> beta-> Bool-> beta
foldBool a1 a2 False = a1
foldBool a1 a2 True  = a2

-- Maybe (the option type)

data Maybe alpha = Nothing | Just alpha

foldMaybe :: beta-> (alpha-> beta)-> Maybe alpha-> beta
foldMaybe b f Nothing  = b
foldMaybe b f (Just a) = f a 

-- Pairs

foldPair :: (alpha-> beta-> gamma)-> (alpha, beta)-> gamma
foldPair f (a, b)= f a b      

-- Natural numbers:

data Nat = Zero | Succ Nat 

foldNat :: beta-> (beta-> beta)-> Nat-> beta
foldNat e f Zero  = e
foldNat e f (Succ n) = f (foldNat e f n)

