module QSortEval where

import System.Random
import Data.Time.Clock
import QSort

randomStr :: Int-> IO String
randomStr n = sequence $ replicate n (randomRIO ('A', 'z'))

time :: String-> (String-> String)-> IO NominalDiffTime
time s sort = do
  s0 <- getCurrentTime
  putStrLn $ show (length (sort s))
  s1 <- getCurrentTime
  return $ diffUTCTime s1 s0

main = do
  str <- randomStr 100000
  t1 <- time str qsort1
  putStrLn $ "Time qsort1: " ++ show t1
  t2 <- time str qsort2
  putStrLn $ "Time qsort2: " ++ show t2
  t3 <- time str qsort3
  putStrLn $ "Time qsort3: " ++ show t3
  t4 <- time str qsort4
  putStrLn $ "Time qsort4: " ++ show t4
  t5 <- time str qsort5
  putStrLn $ "Time qsort5: " ++ show t5
  
