module Queens where

type Pos = (Int, Int)

type Board = [Pos]

queens :: Int-> [Board]
queens n = qu n where
  qu :: Int-> [Board]
  qu i | i == 0  = [[]]
       | otherwise = 
     [ p++ [(i, j)] | p <- qu (i-1), j <- [1.. n], 
                      safe p (i, j)]

safe :: Board-> Pos-> Bool
safe others nu = 
   and [ not (threatens other nu) | other <- others ]

threatens :: Pos-> Pos-> Bool
threatens (i, j) (m, n) = 
   (j== n) || (i+j == m+n) || (i-j == m-n)

-- A nicer output
render :: Int-> Board-> String
render n ps =
    "\n+" ++ replicate n '-' ++ "+\n" ++
    unlines ["|" ++ line ps i ++ "|" | i <- [1..n]] ++
    "+" ++ replicate n '-' ++ "+\n" where
      line ps y = [ if (x,y) `elem` ps then '*' else '.' | x <- [1..n]]
