module Unfold where

-- import 

unfold :: (beta-> Maybe (alpha, beta))-> beta-> [alpha]
unfold g b =
  case g b of Just (a, bs) -> a: unfold g bs
              Nothing -> []

digits :: Integer-> [Integer]
digits =
  reverse . unfold (\n-> if n > 0 then Just (n `mod` 10, n `div` 10)
                                  else Nothing) 

primes :: [Integer]
primes =
  unfold (\ns-> Just (head ns,
                      filter (\n-> n `mod` head ns /= 0) (tail ns)))
         [2..]
         
